# -*- coding: utf-8 -*-
"""Todo02.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1vQxxO0bO2C3XXA2FPD-MKOkIJrC2Y3td

**Exploring Data using pandas**

**1. Loading Data**
"""

import pandas as pd
#Reading excel file
df=pd.read_excel('yelp.xlsx', sheet_name='yelp_data')
df

"""**2. Understanding Data**"""

df.head()

df.head(20)

df.tail()

df.tail(10)

df[10:20]

df.shape

df.ndim

df.columns

df.size

df.dtypes

df['stars'].dtypes

df.count()

"""**3. Summarising and computing descriptive statistics**

Calling DataFrame’s sum method returns a Series containing column sums. Passing axis=1 sums over the rows instead
"""

df.sum()

df.sum(axis = 1)

df[['review_count','stars']].agg(['min','mean','max','std'])

df.mean()

df.mean(axis = 1)

df.mode()

df.describe

df['name'].describe()

"""**4. Looking for missing data**

*   pandas uses the floating point value NaN (Not a Number) to represent missing data in
both floating as well as in non-floating point arrays.
*   The built-in Python None value is also treated as NA in object arrays:
"""

df.isnull()

df.isnull().sum()

df.isna().sum()

"""**5. Handling Missing Value (Numerical)**

**5.1 Droping missing values**

DataFrame.dropna(axis=0, how='any', thresh=None, subset=None, inplace=False)
"""

#dropna() drops any row containing missing values. 
newdf = df.dropna()
newdf

newdf.shape

filtered_df = df[df.notnull()]
filtered_df.shape

newdf1 = df.dropna(axis = 1)
newdf1.head()

"""**5.2 Filling Missing value**

Rather than filtering out missing data (and potentially discarding other data along with
it), you may want to fill in the “holes” in any number of ways. For most purposes, the
fillna method is the workhorse function to use. Calling fillna with a constant replaces
missing values with that value:

DataFrame.fillna(value=None, method=None, axis=None, inplace=False, limit=None, downcast=None)
"""

#using fillna() without any paramters
df.fillna(0)

#Replacing missing value by mode
df.fillna(df.mode())